/*******************************************************************************

  Filters used by Example Plugin Library (DLL) for DIMIN Viewer n5 (DIV5)

  Programmer: Dima V. Fedorov Levit <dimin@dimin.net> <http://www.dimin.net/>

  History:
    06/01/2005 22:17 - First Creation
    
*******************************************************************************/

#include <stdio.h>
#include <windows.h>
#include <math.h>

#include <string>
#include <vector>
#include <algorithm>

#include "div5_morphology.h"

#include "DIVPluginDefs.h"
#include "DIVFilterDefs.h"
#include "DIVFilterUtils.h"

#include "morphology.h"


//******************************************************************************
// filter 01 
//******************************************************************************

int __stdcall filterDilationSquare3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    dilateSquare33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterDilationCross3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    dilateCross33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterErosionSquare3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    erodeSquare33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterErosionCross3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    erodeCross33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterOpeningSquare3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    openSquare33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterOpeningCross3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    openCross33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterClosingSquare3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    closeSquare33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}

int __stdcall filterClosingCross3x3( TDIVParameters *par )
{
  if ( par->ver < sizeof(TDIVParameters) ) return 1;
  if (par->hbmp == 0) return 1;
  BITMAP inbmp;
  GetObject(par->hbmp, sizeof(BITMAP), (LPSTR)&inbmp);

  try
  {
    unsigned int amount=1;
    getUIntArg ( par, 0, amount );

    closeCross33( par, &inbmp, amount );
  }
  catch ( ... )
  {
    return 1;
  }

  return 0;
}



